//
//  MySQL.h
//  MySQL Connector
//
//  Created by Shahrooz Alimohammadi on 07.08.17.
//  Copyright Â© 2017 Shahrooz Alimohammadi. All rights reserved.
//
//  To B4i created Lajos Nagy on 2020.04.06.
//

#import <Foundation/Foundation.h>
#import "/Applications/B4i/Include/mysql.h"
#import "/Applications/B4i/Libs/iCore.h"

@class B4I;

//~Shortname: iMySQL
//~Event:Initialize
//~Event:ConnectTo (Host As String, Username AS String, Password As String, Database As String) as Boolean
//~Event:RunQuery (Query As string)
//~Event:FetchResult as List
//~Event:Close
//~Version:1.00
//~Author: Shahrooz Alimohammadi & Lajos Nagy
//~DependsOn: libmysqlclient.21.dylib

@interface iMySql : NSObject
{
    MYSQL *Mysql_connection, Mysql;
    MYSQL_ROW Mysql_row;
    MYSQL_RES *Mysql_result;
}


- (id)Initialize :(B4I *)bi ;

- (BOOL)ConnectTo :(NSString*)Host :(NSString*)Username :(NSString*)Password :(NSString*)Database;

- (void)RunQuery :(NSString*)Query;

- (NSArray*)FetchResult;

- (void)Close;

@end
