//
//  iMySql.m
//  iMySql
//
//  Created by Nagy Lajos on 2020. 04. 06..
//  Copyright © 2020. Nagy Lajos. All rights reserved.
//

#import "iMySql.h"
#import "/Applications/B4i/Libs/iCore.h"

@implementation iMySql

- (id)Initialize :(B4I *)bi {
    mysql_init(&Mysql);
    return self;
}

- (BOOL)ConnectTo :(NSString *)Host :(NSString *)Username :(NSString *)Password :(NSString *)Database {
    const char* c_host = [Host UTF8String];
    const char* c_username = [Username UTF8String];
    const char* c_password = [Password UTF8String];
    const char* c_database = [Database UTF8String];
    
    Mysql_connection = mysql_real_connect(&Mysql, c_host, c_username, c_password, c_database, 0, 0, 0);
    
    if (Mysql_connection == NULL) return NO;
    return YES;
}

- (void)RunQuery:(NSString *)Query {
    const char* c_query = [Query UTF8String];
    mysql_query(Mysql_connection, c_query);
}

- (NSArray *)FetchResult {
    NSMutableArray *tmp = [[NSMutableArray alloc] init];
    
    Mysql_result = mysql_store_result(Mysql_connection);
    unsigned int count = mysql_num_fields(Mysql_result);
    unsigned int i;
    MYSQL_FIELD *fields  = mysql_fetch_fields(Mysql_result);
    while ((Mysql_row = mysql_fetch_row(Mysql_result)) != NULL){
        NSMutableDictionary *tmp2 = [[NSMutableDictionary alloc] init];
        
        for (i=0; i< count; i++){
            [tmp2 setObject:[NSString stringWithFormat:@"%s", Mysql_row[i]] forKey:[NSString stringWithFormat:@"%s", fields[i].name]];
        }
        [tmp addObject:tmp2];
    }
    
    return [NSArray arrayWithArray:tmp];
}

- (void)Close {
    mysql_free_result(Mysql_result);
    mysql_close(Mysql_connection);
}
@end
